#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include "callbacks.h"

extern GtkWidget *commander_window;
extern GtkWidget *porthole_window;
extern GtkWidget *color_window;
extern GtkWidget *aperture_window;
extern GtkWidget *status_window;
extern GtkWidget *about_window;
extern GtkWidget *file_selector_window;
extern GtkWidget *capture_window;
extern GtkWidget *temperature_window;
extern dc1394_camerainfo camera;
extern int current_memory_channel;
extern int max_memory_channel;

gboolean
on_commander_window_delete_event       (GtkWidget       *widget,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{
  gtk_exit(0);
  return FALSE;
}


void
on_file_activate                       (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  // function intentionnaly left blank: intermediate menu
}


void
on_load_setup_activate                 (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  GtkWidget *dialog = create_file_selector_window();
  gtk_window_set_title (GTK_WINDOW (dialog), "Select a setup file to load...");
  gtk_widget_show(dialog);

  // to be continued...
}


void
on_save_setup_activate                 (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  // TO BE FILLED
}


void
on_save_setup_as_activate              (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  GtkWidget *dialog = create_file_selector_window();
  gtk_window_set_title (GTK_WINDOW (dialog), "Save setup as...");
  gtk_widget_show(dialog);

  // to be continued...
}


void
on_exit_activate                       (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  gtk_exit(0);
}


void
on_porthole_activate                   (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  gtk_widget_show (porthole_window);
}


void
on_color_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  gtk_widget_show (color_window);
}


void
on_aperture_activate                   (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  gtk_widget_show (aperture_window);
}


void
on_format_activate                     (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  // function intentionnaly left blank: intermediate menu
}


void
on_format_0_activate                   (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  // function intentionnaly left blank: intermediate menu
}



void
on_format_1_activate                   (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  // function intentionnaly left blank: intermediate menu
}

void
on_format_2_activate                   (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  // function intentionnaly left blank: intermediate menu
}


void
on_format_6_activate                   (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  // function intentionnaly left blank: intermediate menu
}


void
on_format_7_activate                   (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  // function intentionnaly left blank: intermediate menu
}

void
on_help_activate                       (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  // function intentionnaly left blank: intermediate menu
}


void
on_about_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  about_window = create_about_window ();
  gtk_widget_show (about_window);
}


gboolean
on_file_selector_window_delete_event   (GtkWidget       *widget,
                                        GdkEvent        *event,
                                        gpointer         user_data)
{
  GtkWidget *dialog = gtk_widget_get_toplevel(widget);
  gtk_widget_destroy(dialog);
  return FALSE;
}

void
on_f0_mode0_activate                   (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  int err;
  err=dc1394_set_video_format(camera.handle,camera.id,0);
  err=dc1394_set_video_mode(camera.handle,camera.id,0);
  UpdateFpsMenu(&camera,commander_window);
}


void
on_f0_mode1_activate                   (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  int err;
  err=dc1394_set_video_format(camera.handle,camera.id,0);
  err=dc1394_set_video_mode(camera.handle,camera.id,1);
  UpdateFpsMenu(&camera,commander_window);
}


void
on_f0_mode2_activate                   (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  int err;
  err=dc1394_set_video_format(camera.handle,camera.id,0);
  err=dc1394_set_video_mode(camera.handle,camera.id,2);
  UpdateFpsMenu(&camera,commander_window);
}


void
on_f0_mode3_activate                   (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  int err;
  err=dc1394_set_video_format(camera.handle,camera.id,0);
  err=dc1394_set_video_mode(camera.handle,camera.id,3);
  UpdateFpsMenu(&camera,commander_window);
}


void
on_f0_mode4_activate                   (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  int err;
  err=dc1394_set_video_format(camera.handle,camera.id,0);
  err=dc1394_set_video_mode(camera.handle,camera.id,4);
  UpdateFpsMenu(&camera,commander_window);
}


void
on_f0_mode5_ativate                    (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  int err;
  err=dc1394_set_video_format(camera.handle,camera.id,0);
  err=dc1394_set_video_mode(camera.handle,camera.id,5);
  UpdateFpsMenu(&camera,commander_window);
}


void
on_f1_mode0_activate                   (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  int err;
  err=dc1394_set_video_format(camera.handle,camera.id,1);
  err=dc1394_set_video_mode(camera.handle,camera.id,0);
  UpdateFpsMenu(&camera,commander_window);
}


void
on_f1_mode1_activate                   (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  int err;
  err=dc1394_set_video_format(camera.handle,camera.id,1);
  err=dc1394_set_video_mode(camera.handle,camera.id,1);
  UpdateFpsMenu(&camera,commander_window);
}


void
on_f1_mode2_activate                   (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  int err;
  err=dc1394_set_video_format(camera.handle,camera.id,1);
  err=dc1394_set_video_mode(camera.handle,camera.id,2);
  UpdateFpsMenu(&camera,commander_window);
}


void
on_f1_mode3_activate                   (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  int err;
  err=dc1394_set_video_format(camera.handle,camera.id,1);
  err=dc1394_set_video_mode(camera.handle,camera.id,3);
  UpdateFpsMenu(&camera,commander_window);
}


void
on_f1_mode4_activate                   (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  int err;
  err=dc1394_set_video_format(camera.handle,camera.id,1);
  err=dc1394_set_video_mode(camera.handle,camera.id,4);
  UpdateFpsMenu(&camera,commander_window);
}


void
on_f1_mode5_activate                   (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  int err;
  err=dc1394_set_video_format(camera.handle,camera.id,1);
  err=dc1394_set_video_mode(camera.handle,camera.id,5);
  UpdateFpsMenu(&camera,commander_window);
}


void
on_f2_mode0_activate                   (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  int err;
  err=dc1394_set_video_format(camera.handle,camera.id,2);
  err=dc1394_set_video_mode(camera.handle,camera.id,0);
  UpdateFpsMenu(&camera,commander_window);
}


void
on_f2_mode1_activate                   (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  int err;
  err=dc1394_set_video_format(camera.handle,camera.id,2);
  err=dc1394_set_video_mode(camera.handle,camera.id,1);
  UpdateFpsMenu(&camera,commander_window);
}


void
on_f2_mode2_activate                   (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  int err;
  err=dc1394_set_video_format(camera.handle,camera.id,2);
  err=dc1394_set_video_mode(camera.handle,camera.id,2);
  UpdateFpsMenu(&camera,commander_window);
}


void
on_f2_mode3_activate                   (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  int err;
  err=dc1394_set_video_format(camera.handle,camera.id,2);
  err=dc1394_set_video_mode(camera.handle,camera.id,3);
  UpdateFpsMenu(&camera,commander_window);
}


void
on_f2_mode4_activate                   (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  int err;
  err=dc1394_set_video_format(camera.handle,camera.id,2);
  err=dc1394_set_video_mode(camera.handle,camera.id,4);
  UpdateFpsMenu(&camera,commander_window);
}


void
on_f2_mode5_activate                   (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  int err;
  err=dc1394_set_video_format(camera.handle,camera.id,2);
  err=dc1394_set_video_mode(camera.handle,camera.id,5);
  UpdateFpsMenu(&camera,commander_window);
}


void
on_f6_mode0_activate                   (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  int err;
  err=dc1394_set_video_format(camera.handle,camera.id,6);
  err=dc1394_set_video_mode(camera.handle,camera.id,0);
  UpdateFpsMenu(&camera,commander_window);
}


void
on_f7_mode0_activate                   (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  int err;
  err=dc1394_set_video_format(camera.handle,camera.id,7);
  err=dc1394_set_video_mode(camera.handle,camera.id,0);
  UpdateFpsMenu(&camera,commander_window);
}


void
on_f7_mode1_activate                   (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  int err;
  err=dc1394_set_video_format(camera.handle,camera.id,7);
  err=dc1394_set_video_mode(camera.handle,camera.id,1);
  UpdateFpsMenu(&camera,commander_window);
}


void
on_f7_mode2_activate                   (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  int err;
  err=dc1394_set_video_format(camera.handle,camera.id,7);
  err=dc1394_set_video_mode(camera.handle,camera.id,2);
  UpdateFpsMenu(&camera,commander_window);
}


void
on_f7_mode3_activate                   (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  int err;
  err=dc1394_set_video_format(camera.handle,camera.id,7);
  err=dc1394_set_video_mode(camera.handle,camera.id,3);
  UpdateFpsMenu(&camera,commander_window);
}


void
on_f7_mode4_activate                   (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  int err;
  err=dc1394_set_video_format(camera.handle,camera.id,7);
  err=dc1394_set_video_mode(camera.handle,camera.id,4);
  UpdateFpsMenu(&camera,commander_window);
}


void
on_f7_mode5_activate                   (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  int err;
  err=dc1394_set_video_format(camera.handle,camera.id,7);
  err=dc1394_set_video_mode(camera.handle,camera.id,5);
  UpdateFpsMenu(&camera,commander_window);
}


void
on_f7_mode6_activate                   (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  int err;
  err=dc1394_set_video_format(camera.handle,camera.id,7);
  err=dc1394_set_video_mode(camera.handle,camera.id,6);
  UpdateFpsMenu(&camera,commander_window);
}


void
on_f7_mode7_activate                   (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  int err;
  err=dc1394_set_video_format(camera.handle,camera.id,7);
  err=dc1394_set_video_mode(camera.handle,camera.id,7);
  UpdateFpsMenu(&camera,commander_window);
}


void
on_fps_menu_activate                   (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  // function intentionnaly left blank: intermediate menu
}


void
on_fps1875_activate                    (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  int err;
  err=dc1394_set_video_framerate(camera.handle, camera.id, FRAMERATE_1_875);
}


void
on_fps375_activate                     (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  int err;
  err=dc1394_set_video_framerate(camera.handle, camera.id, FRAMERATE_3_75);
}


void
on_fps75_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  int err;
  err=dc1394_set_video_framerate(camera.handle, camera.id, FRAMERATE_7_5);
}


void
on_fps15_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  int err;
  err=dc1394_set_video_framerate(camera.handle, camera.id, FRAMERATE_15);
}


void
on_fps30_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  int err;
  err=dc1394_set_video_framerate(camera.handle, camera.id, FRAMERATE_30);
}


void
on_fps60_activate                      (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  int err;
  err=dc1394_set_video_framerate(camera.handle, camera.id, FRAMERATE_60);
}


void
on_power_on_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{
  int err;
  err=dc1394_camera_on(camera.handle, camera.id);
}


void
on_power_off_clicked                   (GtkButton       *button,
                                        gpointer         user_data)
{
  int err;
  err=dc1394_camera_off(camera.handle, camera.id);
}


void
on_power_reset_clicked                 (GtkButton       *button,
                                        gpointer         user_data)
{
  int err;
  err=dc1394_init_camera(camera.handle, camera.id);
  

}

void
on_trigger_polarity_toggled            (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
  // should be completed
}


void
on_pan_op_clicked                      (GtkButton       *button,
                                        gpointer         user_data)
{
  OpRangeProcedure(button, FEATURE_PAN);
}


void
on_pan_power_toggled                   (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
  PowerRangeProcedure(togglebutton,FEATURE_PAN);
}


void
on_tilt_power_toggled                  (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
  PowerRangeProcedure(togglebutton,FEATURE_TILT);
}


void
on_tilt_op_clicked                     (GtkButton       *button,
                                        gpointer         user_data)
{
  OpRangeProcedure(button,FEATURE_TILT);
}


void
on_zoom_power_toggled                  (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
  PowerRangeProcedure(togglebutton,FEATURE_ZOOM);
}


void
on_zoom_op_clicked                     (GtkButton       *button,
                                        gpointer         user_data)
{
  OpRangeProcedure(button,FEATURE_ZOOM);
}


void
on_focus_op_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{
  OpRangeProcedure(button,FEATURE_FOCUS);
}


void
on_focus_power_toggled                 (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
  PowerRangeProcedure(togglebutton,FEATURE_FOCUS);
}


void
on_brightness_op_clicked               (GtkButton       *button,
                                        gpointer         user_data)
{
  OpRangeProcedure(button,FEATURE_BRIGHTNESS);
}


void
on_brightness_power_toggled            (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
  PowerRangeProcedure(togglebutton,FEATURE_BRIGHTNESS);
}


void
on_gamma_op_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{
  OpRangeProcedure(button,FEATURE_GAMMA);
}


void
on_gamma_power_toggled                 (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
  PowerRangeProcedure(togglebutton,FEATURE_GAMMA);
}


void
on_saturation_op_clicked               (GtkButton       *button,
                                        gpointer         user_data)
{
  OpRangeProcedure(button,FEATURE_SATURATION);
}


void
on_saturation_power_toggled            (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
  PowerRangeProcedure(togglebutton,FEATURE_SATURATION);
}


void
on_hue_op_clicked                      (GtkButton       *button,
                                        gpointer         user_data)
{
  OpRangeProcedure(button,FEATURE_HUE);
}


void
on_hue_power_toggled                   (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
  PowerRangeProcedure(togglebutton,FEATURE_HUE);
}


void
on_whitebal_power_toggled              (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
  PowerRangeProcedure(togglebutton,FEATURE_WHITE_BALANCE);
}


void
on_whitebal_op_clicked                 (GtkButton       *button,
                                        gpointer         user_data)
{
  OpRangeProcedure(button,FEATURE_WHITE_BALANCE);
}


void
on_sharpness_op_clicked                (GtkButton       *button,
                                        gpointer         user_data)
{
  OpRangeProcedure(button,FEATURE_SHARPNESS);
}


void
on_sharpness_power_toggled             (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
  PowerRangeProcedure(togglebutton,FEATURE_SHARPNESS);
}


void
on_exposure_power_toggled              (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
  PowerRangeProcedure(togglebutton,FEATURE_EXPOSURE);
}


void
on_exposure_op_clicked                 (GtkButton       *button,
                                        gpointer         user_data)
{
  OpRangeProcedure(button,FEATURE_EXPOSURE);
}


void
on_iris_power_toggled                  (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
  PowerRangeProcedure(togglebutton,FEATURE_IRIS);
}


void
on_iris_op_clicked                     (GtkButton       *button,
                                        gpointer         user_data)
{
  OpRangeProcedure(button,FEATURE_IRIS);
}


void
on_shutter_power_toggled               (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
  PowerRangeProcedure(togglebutton,FEATURE_SHUTTER);
}


void
on_shutter_op_clicked                  (GtkButton       *button,
                                        gpointer         user_data)
{
  OpRangeProcedure(button,FEATURE_SHUTTER);
}


void
on_gain_power_toggled                  (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
  PowerRangeProcedure(togglebutton,FEATURE_GAIN);
}


void
on_gain_op_clicked                     (GtkButton       *button,
                                        gpointer         user_data)
{
  OpRangeProcedure(button,FEATURE_GAIN);
}


void
on_filter_power_toggled                (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
  PowerRangeProcedure(togglebutton,FEATURE_OPTICAL_FILTER);
}


void
on_filter_op_clicked                   (GtkButton       *button,
                                        gpointer         user_data)
{
  OpRangeProcedure(button,FEATURE_OPTICAL_FILTER);
}


void
on_pan_man_toggled                     (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
  ManRangeProcedure(togglebutton,FEATURE_PAN);
}


void
on_pan_auto_toggled                    (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
  AutoRangeProcedure(togglebutton,FEATURE_PAN);
}


void
on_tilt_man_toggled                    (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
  ManRangeProcedure(togglebutton,FEATURE_TILT);
}


void
on_tilt_auto_toggled                   (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
  AutoRangeProcedure(togglebutton,FEATURE_TILT);
}


void
on_zoom_man_toggled                    (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
  ManRangeProcedure(togglebutton,FEATURE_ZOOM);
}


void
on_zoom_auto_toggled                   (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
  AutoRangeProcedure(togglebutton,FEATURE_ZOOM);
}


void
on_focus_man_toggled                   (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
  ManRangeProcedure(togglebutton,FEATURE_FOCUS);
}


void
on_focus_auto_toggled                  (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
  AutoRangeProcedure(togglebutton,FEATURE_FOCUS);
}


void
on_brightness_man_toggled              (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
  ManRangeProcedure(togglebutton,FEATURE_BRIGHTNESS);
}


void
on_brightness_auto_toggled             (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
  AutoRangeProcedure(togglebutton,FEATURE_BRIGHTNESS);
}


void
on_gamma_man_toggled                   (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
  ManRangeProcedure(togglebutton,FEATURE_GAMMA);
}


void
on_gamma_auto_toggled                  (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
  AutoRangeProcedure(togglebutton,FEATURE_GAMMA);
}


void
on_saturation_man_toggled              (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
  ManRangeProcedure(togglebutton,FEATURE_SATURATION);
}


void
on_saturation_auto_toggled             (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
  AutoRangeProcedure(togglebutton,FEATURE_SATURATION);
}


void
on_hue_man_toggled                     (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
  ManRangeProcedure(togglebutton,FEATURE_HUE);
}


void
on_hue_auto_toggled                    (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
  AutoRangeProcedure(togglebutton,FEATURE_HUE);
}


void
on_whitebal_man_toggled                (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
  ManRangeProcedure(togglebutton,FEATURE_WHITE_BALANCE);
}


void
on_whitebal_auto_toggled               (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
  AutoRangeProcedure(togglebutton,FEATURE_WHITE_BALANCE);
}


void
on_sharpness_man_toggled               (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
  ManRangeProcedure(togglebutton,FEATURE_SHARPNESS);
}


void
on_sharpness_auto_toggled              (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
  AutoRangeProcedure(togglebutton,FEATURE_SHARPNESS);
}


void
on_exposure_man_toggled                (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
  ManRangeProcedure(togglebutton,FEATURE_EXPOSURE);
}


void
on_exposure_auto_toggled               (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
  AutoRangeProcedure(togglebutton,FEATURE_EXPOSURE);
}


void
on_iris_man_toggled                    (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
  ManRangeProcedure(togglebutton,FEATURE_IRIS);
}


void
on_iris_auto_toggled                   (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
  AutoRangeProcedure(togglebutton,FEATURE_IRIS);
}


void
on_shutter_man_toggled                 (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
  ManRangeProcedure(togglebutton,FEATURE_SHUTTER);
}


void
on_shutter_auto_toggled                (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
  AutoRangeProcedure(togglebutton,FEATURE_SHUTTER);
}


void
on_gain_man_toggled                    (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
  ManRangeProcedure(togglebutton,FEATURE_GAIN);
}


void
on_gain_auto_toggled                   (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
  AutoRangeProcedure(togglebutton,FEATURE_GAIN);
}


void
on_filter_man_toggled                  (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
  ManRangeProcedure(togglebutton,FEATURE_OPTICAL_FILTER);
}


void
on_filter_auto_toggled                 (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
  AutoRangeProcedure(togglebutton,FEATURE_OPTICAL_FILTER);
}

void
on_trigger_mode_activate              (GtkMenuItem     *menuitem,
				       gpointer         user_data)
{
  int err;
  err=dc1394_set_trigger_mode(camera.handle, camera.id, (int)user_data);
  if ((int)user_data==0)
    { // mode 0, internal trigger
      gtk_widget_set_sensitive(lookup_widget(GTK_WIDGET (menuitem),"fps"),TRUE);
      gtk_widget_set_sensitive(lookup_widget(GTK_WIDGET (menuitem),"trigger_polarity"),FALSE);
    }
  else
    { // mod x, x>0: external trigger
      gtk_widget_set_sensitive(lookup_widget(GTK_WIDGET (menuitem),"fps"),FALSE);
      gtk_widget_set_sensitive(lookup_widget(GTK_WIDGET (menuitem),"trigger_polarity"),TRUE);
    }
}

void
on_memory_channel_activate              (GtkMenuItem     *menuitem,
					 gpointer         user_data)
{
  current_memory_channel=(int)user_data; // user data is an int.
  if ((int)user_data>0)
    { // save allowed:
      gtk_widget_set_sensitive(lookup_widget(GTK_WIDGET (menuitem),"save_mem"),(max_memory_channel>0));
    }
  else
    { // save not allowed:
      gtk_widget_set_sensitive(lookup_widget(GTK_WIDGET (menuitem),"save_mem"),FALSE);
    }
}


void
on_status_activate                     (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  gtk_widget_show (status_window);
}


void
on_capture_activate                    (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  gtk_widget_show (capture_window);
}


void
on_capqual_man_toggled                 (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
  ManRangeProcedure(togglebutton,FEATURE_CAPTURE_QUALITY);
}


void
on_capqual_auto_toggled                (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
  AutoRangeProcedure(togglebutton,FEATURE_CAPTURE_QUALITY);
}


void
on_capqual_op_clicked                  (GtkButton       *button,
                                        gpointer         user_data)
{
  OpRangeProcedure(button,FEATURE_CAPTURE_QUALITY);
}


void
on_capqual_power_toggled               (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
  PowerRangeProcedure(togglebutton,FEATURE_CAPTURE_QUALITY);
}


void
on_capsize_man_toggled                 (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
  ManRangeProcedure(togglebutton,FEATURE_CAPTURE_SIZE);
}


void
on_capsize_auto_toggled                (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
  AutoRangeProcedure(togglebutton,FEATURE_CAPTURE_SIZE);
}


void
on_capsize_op_clicked                  (GtkButton       *button,
                                        gpointer         user_data)
{
  OpRangeProcedure(button,FEATURE_CAPTURE_SIZE);
}


void
on_capsize_power_toggled               (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
  PowerRangeProcedure(togglebutton,FEATURE_CAPTURE_SIZE);
}

void
on_capture_start_clicked               (GtkButton       *button,
                                        gpointer         user_data)
{
  // use video1394 to capture pictures:
}


void
on_capture_stop_clicked                (GtkButton       *button,
                                        gpointer         user_data)
{
  // release video1394 ressources, write file
}


void
on_capture_single_clicked              (GtkButton       *button,
                                        gpointer         user_data)
{
  // get one frame and leave
}

void
on_temp_power_toggled                  (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
  PowerRangeProcedure(togglebutton,FEATURE_TEMPERATURE);
}


void
on_temp_man_toggled                    (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
  ManRangeProcedure(togglebutton,FEATURE_TEMPERATURE);
}


void
on_temp_auto_toggled                   (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
  AutoRangeProcedure(togglebutton,FEATURE_TEMPERATURE);
}


void
on_temp_op_clicked                     (GtkButton       *button,
                                        gpointer         user_data)
{
  OpRangeProcedure(button,FEATURE_TEMPERATURE);
}


void
on_temp_window_activate                (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
  gtk_widget_show (temperature_window);
}


void
on_set_all_auto_clicked                (GtkButton       *button,
                                        gpointer         user_data)
{
  // for each feature, set to auto if available, else set to OP/auto, else do nothing
}


void
on_set_all_man_clicked                 (GtkButton       *button,
                                        gpointer         user_data)
{
  // for each feature, set to man if available, else do nothing
}


void
on_lock_setup_toggled                  (GtkToggleButton *togglebutton,
                                        gpointer         user_data)
{
  // pressed: set all to man, then lock all controls
  // depressed: unlock all available controls
}

// the two following funcs are under development...

void
on_load_mem_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{
  // int err;
  // err=dc1394_memory_load(camera.handle,camera.id, current_memory_channel);
  // UPDATE ALL WIDGETS HERE

}


void
on_save_mem_clicked                    (GtkButton       *button,
                                        gpointer         user_data)
{ /*
  int err;
  dc1394bool_t boolean;
  err=dc1394_set_memory_save_ch(camera.handle,camera.id, current_memory_channel);
  err=dc1394_memory_save(camera.handle,camera.id);
  boolean=TRUE;
  while(boolean)
    { // wait for save to be completed:
      err=dc1394_is_memory_save_in_operation(camera.handle,camera.id, &boolean);
    }
  */
}

